
// ThreadTestDlg.cpp : t@C
//

#include "stdafx.h"
#include "ThreadTest.h"
#include "ThreadTestDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CThreadTestDlg _CAO

static UINT ExecProc( LPVOID pParam );



CThreadTestDlg::CThreadTestDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CThreadTestDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pThread = NULL;
	m_Stop = FALSE;
}

void CThreadTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_MSG, m_stcMsg);
	DDX_Control(pDX, IDC_STATIC_RESULT, m_stcResult);
}

#define WM_APP_THREADEND (WM_APP + 1)

BEGIN_MESSAGE_MAP(CThreadTestDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CThreadTestDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CThreadTestDlg::OnBnClickedButton2)
	ON_MESSAGE(WM_APP_THREADEND, OnThreadEnd)
END_MESSAGE_MAP()

// CThreadTestDlg bZ[W nh[

BOOL CThreadTestDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	UpdateMsg( 0 );  // bZ[W
	GetDlgItem(IDC_BUTTON2)->EnableWindow(0);  // ~{^𖳌
	m_stcResult.SetWindowText(_T(""));  // ʕNA

	return TRUE;
}

// Jn{^
void CThreadTestDlg::OnBnClickedButton1()
{
	GetDlgItem(IDC_BUTTON1)->EnableWindow(0);  // Jn{^𖳌
	GetDlgItem(IDC_BUTTON2)->EnableWindow(1);  // ~{^L
	GetSystemMenu(FALSE)->EnableMenuItem( SC_CLOSE, MF_GRAYED );  // ~{^𖳌
	m_stcResult.SetWindowText( _T("") );  // ʕNA
	UpdateMsg( 0 );  // bZ[W

	// TuXbhJn
	m_pThread = AfxBeginThread( (AFX_THREADPROC)ExecProc, (LPVOID)this, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED, NULL);
	m_pThread->m_bAutoDelete = FALSE;	// jtONA
	m_pThread->ResumeThread();		// TXyh
}

static UINT ExecProc( LPVOID pParam )
{
	CThreadTestDlg* pDlg = (CThreadTestDlg*)pParam;
	pDlg->ExecFunc();
	return 0;
}

void CThreadTestDlg::ExecFunc()
{
	// ̊֐̒TuXbhBTuXbhĂ͂ȂƁB
	// Eʎ̃Rg[iCXbhjύX
	// ECXbhύX\ϐύX
	// 悤ɁACƃTuł͈̓ƗۂׂƂ
	try
	{
		for( int i=0; i<10; i++ )
		{
			Sleep(1000); // Ԃ鏈
			if( m_Stop )  // ~ꂽtOāA[v𔲂
				break;
			UpdateMsg( i+1 );
		}
		if( m_Stop )
			m_strResult = _T("~ꂽB");  // ̓o[ϐg킸ɁAbZ[Wp[^œnق̂BB
		else
			m_strResult = _T("Ō܂ŎsꂽB");
	}
	catch(...)
	{
		m_strResult = _T("ُIB");
	}
	PostMessage( WM_APP_THREADEND, 0, 0 );  // TuXbhIƂCXbhɒm点
}

// TuXbhI
LRESULT CThreadTestDlg::OnThreadEnd(WPARAM wParam, LPARAM lParam)
{
	if( !m_pThread )  // TuXbhX^[gĂȂiÔ߃`FbNj
		return 0L;
	WaitForSingleObject( m_pThread->m_hThread, INFINITE );  // TuXbhÎ҂
	delete m_pThread;
	m_pThread = NULL;

	GetDlgItem(IDC_BUTTON1)->EnableWindow(1);  // Jn{^L
	GetDlgItem(IDC_BUTTON2)->EnableWindow(0);  // ~{^𖳌
	GetSystemMenu(FALSE)->EnableMenuItem( SC_CLOSE, MF_ENABLED );  // ~{^L
	m_stcResult.SetWindowText( m_strResult );  // ʂXV
	m_Stop = FALSE;

	return 0L;
}

// ~{^
void CThreadTestDlg::OnBnClickedButton2()
{
	if( !m_pThread )  // TuXbhX^[gĂȂiÔ߃`FbNj
		return;
	m_pThread->SuspendThread();  // TuXbhf
	if( MessageBox(_T("~܂HibZ[W\̓Xbhfj"), _T("mF"), MB_YESNO ) != IDYES )
	{
		m_pThread->ResumeThread();  // TuXbhĊJ
		return;
	}
	m_pThread->ResumeThread();  // TuXbhĊJ
	m_Stop = TRUE;  // ~ꂽtO𗧂ĂiTuXbhmj
	UpdateMsg( 0 );  // bZ[W
}

void CThreadTestDlg::UpdateMsg( int counter )
{
	CString msg;
	msg.Format( _T("Ԃ鏈s %d/10"), counter );
	m_stcMsg.SetWindowText( msg );
}


// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CThreadTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CThreadTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

